<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 13/11/12
 * Time: 18:26
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\FechamentoDia;

use \Geral\Util\DateUtil;


class ExportFactory
{

    private static function validaTG($nrorg, $filial, $dtProc){
        $ctrlEstoque = \Estoque\Util\Parametros::getControlaEstoque();
        $fechMes = new FechamentoMes();
        $dtFechMes = $fechMes->consultaDataFechMes($nrorg, $filial, $dtProc);

        if ($ctrlEstoque === 'S' AND $dtFechMes === false){
            \Estoque\Logic\Exception\ExceptionExportPosFechDia::erroSemDtFechDia();
        }
        return true;
    }

    public static function getInstance($codigo, $nrorg, $filial, $dtProc, $dia, $dtProcProx, $nmArquivo) {
        $fechamentoMes = new FechamentoMes();
        $diaFech = $fechamentoMes->consultaDataFechMes($nrorg, $filial, $dtProc);

        $diaDtProc = DateUtil::getDia(DateUtil::getDataDeString($dtProc));

        if (strpos($codigo, 'ADM0931') AND
            ($dia === 'DI' OR ($dia === 'FM' AND $diaFech === $dtProc) OR $dia === $diaDtProc)
        ){
            return new ExportaRNF(array(
                'DTPROC' => $dtProc, 'CDFILIAL' => $filial, 'NRORG' => $nrorg, 'CDRELATEXP' => $codigo)
            );

        }

        if ((strpos($codigo, 'SAP00200') !== false OR strpos($codigo, 'SAP00201') !== false OR
            strpos($codigo, 'SAP00202') !== false OR strpos($codigo, 'SAP00203') !== false) AND
            ($dia === 'DI' OR ($dia === 'FM' AND $diaFech === $dtProc) OR $dia === $diaDtProc)
        ){
            return new ExportaSAP(array(
                'NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc, 'CDRELATEXP' => $codigo
            ));

        }
        if (((strpos($codigo, 'ADM01310') !== false
           OR strpos($codigo, 'ADM01318') !== false)
           OR (\Estoque\Util\Parametros::getSistemaDos() === '3')) AND
            ($dia === 'DI' OR ($dia === 'FM' AND $diaFech === $dtProc) OR $dia === $diaDtProc)){
            self::validaTG($nrorg, $filial, $dtProc);
            return new ExportaTG(array('NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc));
        }

        if ((strpos($codigo, 'ADM01317') !== false OR strpos($codigo, 'ADM01325') !== false) AND
            ($dia === 'DI' OR ($dia === 'FM' AND $diaFech === $dtProc) OR $dia === $diaDtProc)
        ){
            return new ExportaTI(array('NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc));

        }

        if (strpos($codigo, 'CCH03000') !== false){
            return new ExportaNF(array('NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc));

        }

        if (strpos($codigo, 'SDX0931') !== false){
            return new ExportaCFC(array('NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc,
                'CDRELATEXP' => $codigo, 'NMARQTXTEXP' => $nmArquivo));

        }

        if ((strpos($codigo, 'SDX00310') !== false OR strpos($codigo, 'SDX00311') !== false OR
            strpos($codigo, 'SDX00312') !== false OR strpos($codigo, 'SDX00313') !== false OR
            strpos($codigo, 'SDX00314') !== false OR strpos($codigo, 'SDX00315') !== false) AND
            ($dia === 'DI' OR ($dia === 'FM' AND $diaFech === $dtProc) OR $dia === $diaDtProc)
        ){
            $cdMovimentacao = null;

            if (strpos($codigo, 'SDX00313') !== false) {
                $cdMovimentacao = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'MOVIESTOQUE', 20);
                new GeraAjustMov(array('NRORG' => $nrorg, 'CDFILIAL' => $filial,
                    'DTPROC' => $dtProc, 'CDMOVI' => $cdMovimentacao));
            }

            return new ExportaIN86(array('NRORG' => $nrorg, 'CDFILIAL' => $filial, 'DTPROC' => $dtProc,
                'DTPROCPROX' => $dtProcProx, 'NRDIAARQEXP' => $dia, 'CDRELATEXP' => $codigo,
                'CDMOVI' => $cdMovimentacao)
            );

        }
        return false;
    }


}
